CREATE TABLE T_REVIEWED_PALLET(
	[LOCATION_ID] [nvarchar](20) NOT NULL,
	[COMPANY_ID] [nvarchar] (20) NOT NULL,
	[TRIP_NUMBER] [int] NOT NULL,
	[BAY_ID] [nvarchar](20) NOT NULL,
	[START_TIME] [datetime] NULL,
	[END_TIME] [datetime] NULL,
 CONSTRAINT [PK_T_REVIEWED_PALLET] PRIMARY KEY CLUSTERED 
(
	[COMPANY_ID] ASC,
	[LOCATION_ID] ASC,
	[TRIP_NUMBER] ASC,
	[BAY_ID] ASC
));


--Cria tabela ERROR TYPE.

CREATE TABLE [dbo].[T_REVIEW_ERROR_TYPE](


	[ERROR_ID] [nvarchar](20) NOT NULL,
	[ERROR_DESCRIPTION] [nvarchar](45) NOT NULL,
 CONSTRAINT [PK_T_REVIEW_ERROR_TYPE] PRIMARY KEY CLUSTERED 
(
	[ERROR_ID] ASC
));

--Preenche tabela de erros com dados padres
INSERT INTO T_REVIEW_ERROR_TYPE VALUES ('1', 'ERRO DE MONTAGEM');
INSERT INTO T_REVIEW_ERROR_TYPE VALUES ('2', 'ERRO DE FALTA');
INSERT INTO T_REVIEW_ERROR_TYPE VALUES ('3', 'ERRO DE SOBRA');
INSERT INTO T_REVIEW_ERROR_TYPE VALUES ('4', 'ERRO DE INVERSO');

--Adiciona campo ERROR_ID  tabela T_LOAD_PALLET_PRODUCT_SUMMARY.
alter table T_LOAD_PALLET_PRODUCT_SUMMARY add ERROR_ID NVARCHAR(20) foreign key references T_REVIEW_ERROR_TYPE(ERROR_ID);


--Adiciona campo pallet_reviewed  tabela T_LOAD_BAYs
alter table T_LOAD_BAYS add PALLET_REVIEWED bit;

--Marca todos os pallets existentes como conferidos
UPDATE T_LOAD_BAYS SET PALLET_REVIEWED = 1;


--Cria indices para tabela T_LOAD_PALLET_PRODUCT_SUMMARY
CREATE NONCLUSTERED INDEX IDX_LOADREVIEW_TRIPNUMBER_BAYID ON dbo.T_LOAD_PALLET_PRODUCT_SUMMARY
	(
	TRIP_NUMBER DESC,
	BAY_ID
	); 
CREATE NONCLUSTERED INDEX IDX_LOADREVIEW_COMPANY_LOCATION ON dbo.T_LOAD_PALLET_PRODUCT_SUMMARY
	(
	COMPANY_ID,
	LOCATION_ID
	) ;
	
	

