﻿#region

using System;
using System.Collections.Generic;
using LoadReview.Persistencia.Pojo;
using LoadReviewLibrary.Persistencia.Pojo;
using LoadReviewLibrary.Persistencia.Pojo.Generics;

#endregion

namespace LoadReview
{
    internal class CheckBlind : Check
    {
        public CheckBlind(IPallet pallet,
                          CompanyLocation companyLocation)
            : base(pallet, companyLocation)
        {
            AddEventosProduct(pallet.Products);
        }


        //Adiciona Eventos para cada produto
        protected override void AddEventosProduct(List<Product> products)
        {
            base.AddEventosProduct(products);

            for (int i = 0; i < products.Count; i++)
            {
                ProductPDA product = (ProductPDA) products[i];
                product.MontaMascara += montaMascara;
                product.Quantity = int.Parse(product.Mask);
            }
        }

        protected override String montaMascara(int value)
        {
            String mascara = Convert.ToString(value);

            //Se tiver 1 digito mostra: 0*
            if (mascara.Length == 1)
                return "0*";


            //Se tiver 2 dígitos mostra: primeiro digito + *
            if (mascara.Length == 2)
                return "**";


            //Se tiver 3 dígitos mostra: dois primeiros digitos + *
            if (mascara.Length == 3)
                return "***";

            //Se tiver 4 digitios mostra: dois primeiros digitos + **
            if (mascara.Length == 4)
                return "****";

            return null;
        }
    }
}