﻿#region

using System.Windows.Forms;

#endregion

namespace LoadReview
{
    //Implementação do Designer Pattern Singleton.
    internal class Exit
    {
        //variável retornada pelo getInstance
        private static Exit _saida;

        //construtor privado para impedir a "instancia" da classe.
        private Exit()
        {
        }


        public static Exit getInstance()
        {
            if (_saida == null)
                _saida = new Exit();
            return _saida;
        }


        public void ShowMessageSaida()
        {
            DialogResult resposta =
                MessageBox.Show("Todos os dados não gravados serão perdidos - Deseja encerrar ?",
                                "Encerrar", MessageBoxButtons.YesNo,
                                MessageBoxIcon.Question,
                                MessageBoxDefaultButton.Button2);

            if (resposta.Equals(DialogResult.Yes))
                Application.Exit();
        }
    }
}