﻿#region

using System;
using System.Drawing;

#endregion

namespace LoadReview.Grid
{
    public class DataGridCustomColumnButton : DataGridCustomColumnBase
    {
        public Color CorOut { get; set; }
        public Color CorOn { get; set; }


        public virtual void AlteraEstadoButton()
        {
            throw new InvalidOperationException(
                "Propriedade deve ser definida " + "sobrescrevendo AlteraEstadoButton()");
        }


        protected void DrawCheckBox(Graphics g, Rectangle bounds, Boolean state)
        {
            // If I Were A Painter... That would look way better. Sorry.


            int size = bounds.Size.Height < bounds.Size.Width ? bounds.Size.Height : bounds.Size.Width;
            size = size > ((int) g.DpiX/7) ? ((int) g.DpiX/7) : size;

            int boxTop = bounds.Y + (bounds.Height - size)/2;

            using (Brush brush = new SolidBrush(CorOut))
            {
                g.FillEllipse(brush, bounds.X + 2, boxTop, size, size);
            }


// ReSharper disable RedundantBoolCompare
            if (state == true)
// ReSharper restore RedundantBoolCompare
            {
                SolidBrush brush = new SolidBrush(CorOn);
                g.FillEllipse(brush, bounds.X + 2, boxTop, size, size);
            }
        }
    }
}