﻿#region

using System;
using System.Collections;
using System.Drawing;
using System.Windows.Forms;
using LoadReviewLibrary.Persistencia.Pojo;

#endregion

namespace LoadReview.Grid
{
    internal class DataGridCustomColumnButtonGreen : DataGridCustomColumnButton
    {
        #region Delegates

        /// <summary>
        /// Ocorre após o estado da célula for alterado (On/Off).
        /// </summary>
        /// </param>
        public delegate void AlteraEstadoDelegate(String value);

        #endregion

        public event AlteraEstadoDelegate OnAlteraEstadoTrue;
        public event AlteraEstadoDelegate OnAlteraEstadoFalse;


        public override void AlteraEstadoButton()
        {
            Rectangle selectedBounds = Owner.GetCellBounds(Owner.CurrentCell.RowNumber,
                                                           Owner.CurrentCell.ColumnNumber);
            if (!ReadOnly && (ColumnNumber ==
                              Owner.CurrentCell.ColumnNumber) &&
                Owner.HitTest(selectedBounds.Left, selectedBounds.Top).Type
                == DataGrid.HitTestType.Cell &&
                Owner.HitTest(selectedBounds.Right, selectedBounds.Bottom).Type ==
                DataGrid.HitTestType.Cell)
            {
                ArrayList products = (ArrayList) Owner.DataSource;
                Product prodAtual = (Product) products[Owner.CurrentCell.RowNumber];


                if (prodAtual.Verify == false)
                {
                    prodAtual.Verify = true;
                    OnAlteraEstadoTrue(prodAtual.Quantity.ToString());
                }
                else
                {
                    prodAtual.Verify = false;
                    OnAlteraEstadoFalse(prodAtual.Quantity.ToString());
                }
            }
        }


        protected override void Paint(Graphics g, Rectangle bounds,
                                      CurrencyManager source, int rowNum,
                                      Brush backBrush, Brush foreBrush, bool alignToRight)
        {
            DrawBackground(g, bounds, rowNum, backBrush);

            ArrayList products = (ArrayList) Owner.DataSource;
            Product prodAtual = (Product) products[rowNum];

            DrawCheckBox(g, bounds, prodAtual.Verify);
        }
    }
}