﻿#region

using System;
using System.Collections;
using System.Drawing;
using System.Windows.Forms;
using LoadReview.Persistencia.Pojo;
using LoadReviewLibrary.Persistencia.Pojo;

#endregion

namespace LoadReview.Grid
{
    internal class DataGridCustomColumnButtonRed : DataGridCustomColumnButton
    {
        #region Delegates

        /// <summary>
        /// Ocorre após o estado da célula for alterado (On/Off).
        /// </summary>
        /// </param>
        public delegate int AlteraEstadoDelegate();

        #endregion

        public event AlteraEstadoDelegate OnAlteraEstado;

        public override void AlteraEstadoButton()
        {
            Rectangle selectedBounds = Owner.GetCellBounds(Owner.CurrentCell.RowNumber,
                                                           Owner.CurrentCell.ColumnNumber);

            if (!ReadOnly && (ColumnNumber ==
                              Owner.CurrentCell.ColumnNumber) &&
                Owner.HitTest(selectedBounds.Left, selectedBounds.Top).Type
                == DataGrid.HitTestType.Cell &&
                Owner.HitTest(selectedBounds.Right, selectedBounds.Bottom).Type ==
                DataGrid.HitTestType.Cell)
            {
                ArrayList products = (ArrayList) Owner.DataSource;
                Product prodAtual = (Product) products[Owner.CurrentRowIndex];

                if ((prodAtual.ErrorType == null) && (prodAtual.Verify == false))
                {
                    int erro = OnAlteraEstado();
                    prodAtual.ErrorType = ErrorTypePDA.Select(erro.ToString());
                }
            }
        }


        protected override void Paint(Graphics g, Rectangle bounds,
                                      CurrencyManager source, int rowNum,
                                      Brush backBrush, Brush foreBrush, bool alignToRight)
        {
            Boolean state = false;

            DrawBackground(g, bounds, rowNum, backBrush);

            ArrayList products = (ArrayList) Owner.DataSource;
            Product prodAtual = (Product) products[rowNum];

            if (prodAtual.ErrorType != null)
                state = true;

            DrawCheckBox(g, bounds, state);
        }
    }
}