﻿#region

using System.Collections;
using System.Windows.Forms;
using LoadReview.Persistencia.Pojo;

#endregion

namespace LoadReview.Grid
{
    public class DataGridCustomTextBoxColumn : DataGridCustomColumnBase
    {
// ReSharper disable RedundantDefaultFieldInitializer

        //declara o controle que será usado na célula
        private TextBox box = null;
// ReSharper restore RedundantDefaultFieldInitializer

        // retorna a propriedade que pode ser alterada
        protected override string GetBoundPropertyName()
        {
            return "Text";
        }

        //retorna o controle vinculado à coluna
        protected override Control CreateHostedControl()
        {
            box = new TextBox();

            box.BorderStyle = BorderStyle.None;
            box.Multiline = false;
            box.TextAlign = Alignment;

            return box;
        }


        protected override void UpdateHostedControl()
        {
            if (ColumnNumber == 1)
            {
                ArrayList products = (ArrayList) Owner.DataSource;
                ProductPDA prodAtual = (ProductPDA) products[Owner.CurrentRowIndex];

                HostedControl.Text = prodAtual.Mask;

                if (prodAtual.Verify)
                    HostedControl.Enabled = false;
                else
                    HostedControl.Enabled = true;
            }

            base.UpdateHostedControl();
        }
    }
}