﻿#region

using System;
using System.Windows.Forms;
using LoadReview.Persistencia.Dao;
using LoadReviewLibrary.Persistencia.Dao.Generics;
using LoadReviewLibrary.Persistencia.Pojo;
using Microsoft.WindowsCE.Forms;

#endregion

namespace LoadReview
{
    public partial class Login : Form
    {
        private const int ERROR_ID_LOGIN_FAIL = 4;
        private const String ERROR_MSG_LOGIN_FAIL = "Login incorreto. Verifique seu numero de usuário e senha.";


        public Login()
        {
            InitializeComponent();

            SystemSettings.ScreenOrientation =
                ScreenOrientation.Angle0;
        }


        public CompanyLocation authenticate(String user, String senha)
        {
            //cria Dao de funcionário.
            IEmployeeDao daoEmployee =
                DaoFactory.CreateEmployeeDao();
            //obtem funcionário.
            Employee employee =
                (Employee) daoEmployee.Select(txbUser.Text, txbPassword.Text);

            //se login for incorreto
            if (employee == null)
                MessageBox.Show(ERROR_MSG_LOGIN_FAIL, "Login Incorreto",
                                MessageBoxButtons.OK,
                                MessageBoxIcon.Asterisk,
                                MessageBoxDefaultButton.Button2);

                //Se o user e senha estiverem corretos.
            else
            {
                //obtem o CompanyLocation do Employee autenticado.
                ICompanyLocationDao daoCompany =
                    DaoFactory.CreateCompanyLocationDao();
                CompanyLocation companyLocation = daoCompany.Select(employee);
                return companyLocation;
            }

            return null;
        }


        private void btnOk_Click(object sender, EventArgs e)
        {
            CompanyLocation cp = authenticate(txbUser.Text, txbPassword.Text);

            if (cp != null)
            {
                //cria a tela de seleção de data
                SelecaoConferencia data = new SelecaoConferencia(cp);
                data.Show();
            }
        }


        private void menuItem2_Click_1(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void Login_Load(object sender, EventArgs e)
        {
        }
    }
}