﻿using System;
using System.Collections.Generic;
using System.Data.SqlServerCe;
using LoadReview.Persistencia;
using LoadReviewLibrary.Persistencia.Dao.Generics;
using LoadReviewLibrary.Persistencia.Pojo;

namespace LoadReviewLibrary.Persistencia.Dao.Implementation
{
    internal class BayDao : IBayDao
    {
        private const String SQL_SELECT_BAY =
            "SELECT * FROM T_BAY_MASTER WHERE BAY_ID = @Bay AND COMPANY_ID = @Company AND LOCATION_ID = @Location";

        #region IBayDao Members

        public Bay Select(string bay, string cp, string locationId)

        {
            var con = new Connection();
            try
            {
                //cria os parametros
                var bayid = new SqlCeParameter();
                var company = new SqlCeParameter();
                var location = new SqlCeParameter();

                //cria lista para guardar os parametros
                var parameters = new List<SqlCeParameter>();

                //define propriedades dos parametros
                bayid.ParameterName = "Bay";
                bayid.Value = bay;

                company.ParameterName = "Company";
                company.Value = cp;

                location.ParameterName = "Location";
                location.Value = locationId;

                //adiciona os parametros à lista
                parameters.Add(bayid);
                parameters.Add(company);
                parameters.Add(location);

                SqlCeDataReader reader = con.Select(SQL_SELECT_BAY, parameters);

                while (reader.Read())
                {
                    var baia = new Bay(bay, reader.GetString(1));

                    return baia;
                }

                return null;
            }
            finally
            {
                con.Close();
            }
        }

        #endregion
    }
}