﻿#region

using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlServerCe;
using LoadReview.Persistencia;
using LoadReviewLibrary.Persistencia.Dao.Generics;
using LoadReviewLibrary.Persistencia.Pojo;

#endregion

namespace LoadReviewLibrary.Persistencia.Dao.Implementation
{
    public class CompanyDao : ICompanyDao
    {
        private const string SQL_SELECT_COMPANY =
            "SELECT * FROM T_EMPLOYEE_MASTER func, T_COMPANY_MASTER comp WHERE EMPLOYEE_ID = @employeeId AND func.COMPANY_ID = comp.COMPANY_ID";

        #region ICompanyDao Members

        public Company Select(String companyId)
        {
            Company company = null;
            ConnectionPDA con = new ConnectionPDA();

            try
            {
                SqlCeParameter parameter = new SqlCeParameter();
                List<SqlCeParameter> list = new List<SqlCeParameter>();

                parameter.ParameterName = "@Id";
                parameter.SqlDbType = SqlDbType.NVarChar;
                parameter.Value = companyId;

                list.Add(parameter);


                SqlCeDataReader reader = con.Select(SQL_SELECT_COMPANY, list);

                while (reader.Read())
                {
                    company = new Company(reader.GetString(0), reader.GetString(1), reader.GetString(2));
                }

                return company;
            }
            finally
            {
                con.Close();
            }
        }

        public Company Select(Employee emp)
        {
            //cria a conexão.
            ConnectionPDA con = new ConnectionPDA();

            try
            {
                //cria o parametro.
                SqlCeParameter employeeId = new SqlCeParameter();
                //cria a lista que armazena o parametro
                List<SqlCeParameter> list = new List<SqlCeParameter>();

                //define propriedades do parametro @employeeId.
                employeeId.ParameterName = "employeeId";
                employeeId.Value = emp.User;
                employeeId.SqlDbType = SqlDbType.NVarChar;

                //adiciona o parametro a lista.
                list.Add(employeeId);

                //obtem o resultado da consulta Sql
                SqlCeDataReader reader = con.Select(SQL_SELECT_COMPANY, list);

                while (reader.Read())
                {
                    Company company = new Company();
                    company.Id = reader.GetString(5);
                    company.Description = reader.GetString(6);
                    company.Address = reader.GetString(7);

                    return company;
                }

                return null;
            }
            finally
            {
                con.Close();
            }
        }

        #endregion
    }
}