﻿#region

using System;
using System.Windows.Forms;
using LoadReview.Persistencia.Dao;
using LoadReviewLibrary.Persistencia.Dao.Generics;
using LoadReviewLibrary.Persistencia.Pojo;

#endregion

namespace LoadReviewLibrary.Persistencia.Dao.Implementation
{
    internal class CompanyLocationDao : ICompanyLocationDao
    {
//marcação de "ignore" do ReSharper
#pragma warning disable 169
        private const int ERROR_ID_LOCATION_NULL = 1;
        private const int ERROR_ID_COMPANY_NULL = 2;
        private const int ERROR_ID_TYPECONFERENCE_NULL = 3;
//marcação de "ignore" do ReSharper
#pragma warning restore 169


        private const String ERROR_MSG_LOCATION_NULL = "Não foi encontrado uma Company para este usuário";
        private const String ERROR_MSG_COMPANY_NULL = "Não foi encontrado um Location para este usuário";

        private const String ERROR_MSG_TYPECONFERENCE_NULL =
            "Nao foi encontrando um tipo de conferência para este usuário";


        public bool Save(CompanyLocation companyLocation)
        {
            throw new NotImplementedException();
        }

        public bool Delete(CompanyLocation companyLocation)
        {
            throw new NotImplementedException();
        }

        public CompanyLocation Select(Employee employee)
        {
            //cria objeto de retorno
            CompanyLocation companyLocation = new CompanyLocation();

            //obtem os DAOs Company, Location e TypeConference
            ICompanyDao daoCompany = DaoFactory.CreateCompanyDao();
            ILocationDao daoLocation = DaoFactory.CreateLocationDao();
            ITypeConferenceDao daoConference = DaoFactory.CreateTypeConferenceDao();

            //obtem Company, Location e TypeConference
            Company company = daoCompany.Select(employee);
            Location location = daoLocation.Select(employee);
            TypeConference typeConference = daoConference.Select(company.Id, location.Id);


            //testa se resultado da consulta de Company é null.
            if (company == null)
                MessageBox.Show(ERROR_MSG_COMPANY_NULL, "Erro",
                                MessageBoxButtons.OK,
                                MessageBoxIcon.Asterisk,
                                MessageBoxDefaultButton.Button2);
            
                //testa se resultado da consulta de Location é null.
            else if (location == null)
                MessageBox.Show(ERROR_MSG_LOCATION_NULL, "Erro",
                                MessageBoxButtons.OK,
                                MessageBoxIcon.Asterisk,
                                MessageBoxDefaultButton.Button2); 
            
                //testa se resultado da consulta de TypeConference é null
            else if (typeConference == null)
                MessageBox.Show(ERROR_MSG_TYPECONFERENCE_NULL, "Erro",
                                MessageBoxButtons.OK,
                                MessageBoxIcon.Asterisk,
                                MessageBoxDefaultButton.Button2); 
            
                //se nenhum deles for null. Define propriedades de companyLocation 
                //e retorna o objeto.
            else
            {
                companyLocation.Company = company;
                companyLocation.Location = location;
                companyLocation.TypeConferencia = typeConference;
                return companyLocation;
            }

            //se Company, Location ou TypeConference for null retorna null
            return null;
        }
    }
}