﻿#region

using LoadReviewLibrary.Persistencia.Dao.Generics;
using LoadReviewLibrary.Persistencia.Dao.Implementation;

#endregion

namespace LoadReview.Persistencia.Dao
{
    internal class DaoFactory
    {
        public static IProductDao CreateProductDao()
        {
            return new ProductDaoPDA();
        }

        public static ICompanyLocationDao CreateCompanyLocationDao()
        {
            return new CompanyLocationDao();
        }

        public static ICompanyDao CreateCompanyDao()
        {
            return new CompanyDao();
        }

        public static ILocationDao CreateLocationDao()
        {
            return new LocationDao();
        }

        public static ITypeConferenceDao CreateTypeConferenceDao()
        {
            return new TypeConferenceDao();
        }

        public static IEmployeeDao CreateEmployeeDao()
        {
            return new EmployeeDao();
        }

        public static IPalletDao CreatePalletDao()
        {
            return new PalletDaoPDA();
        }

        public static IErrorTypeDao CreateErrorTypeDao()
        {
            return new ErrorTypeDao();
        }

        public static IBayDao CreateBayDao()
        {
            return new BayDaoPDA();
        }

        public static IVehicleDao CreateVehicleDao()
        {
            return new VehicleDao();
        }
    }
}