﻿#region

using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlServerCe;
using LoadReview.Persistencia;
using LoadReviewLibrary.Persistencia.Dao.Generics;
using LoadReviewLibrary.Persistencia.Pojo;
using LoadReviewLibrary.Persistencia.Pojo.Generics;

#endregion

namespace LoadReviewLibrary.Persistencia.Dao.Implementation
{
    internal class EmployeeDao : IEmployeeDao
    {
        private const String SQL_SELECT_EMPLOYEE =
            "SELECT * FROM T_EMPLOYEE_MASTER WHERE EMPLOYEE_ID = @Id AND EMPLOYEE_PASSWORD = @pass";

        #region IEmployeeDao Members

        public IEmployee Select(String user, String pass)
        {
            ConnectionPDA con = new ConnectionPDA();
            try
            {
                //cria objeto de retorno
                Employee retorno = null;


                //cria parametros
                SqlCeParameter employeeId = new SqlCeParameter();
                SqlCeParameter employeePass = new SqlCeParameter();

                //cria lsita para armazenar parametros
                List<SqlCeParameter> list = new List<SqlCeParameter>();

                //define propriedades do parametro @Id
                employeeId.ParameterName = "Id";
                employeeId.SqlDbType = SqlDbType.NVarChar;
                employeeId.Value = user;

                //define propriedades do parametro @pass
                employeePass.ParameterName = "pass";
                employeePass.SqlDbType = SqlDbType.NVarChar;
                employeePass.Value = pass;

                //adicona os parametros à lista
                list.Add(employeeId);
                list.Add(employeePass);


                SqlCeDataReader reader = con.Select(SQL_SELECT_EMPLOYEE, list);


                while (reader.Read())
                {
                    retorno = new Employee(reader.GetString(0), reader.GetString(1));
                }

                return retorno;
            }
            finally
            {
                con.Close();
            }
        }

        #endregion
    }
}