﻿#region

using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlServerCe;
using LoadReviewLibrary.Persistencia.Dao.Generics;
using LoadReviewLibrary.Persistencia.Pojo;

#endregion

namespace LoadReview.Persistencia.Dao
{
    public class ErrorTypeDao : IErrorTypeDao
    {
        #region IErrorTypeDao Members

        public ErrorType Select(string id)
        {
            //cria a conexão
            ConnectionPDA con = new ConnectionPDA();

            try
            {
                const String sql = "SELECT * FROM T_REVIEW_ERROR_TYPE WHERE ERROR_ID = @Id";

                //cria e define as propriedades do parametro @Id
                SqlCeParameter pIdError = new SqlCeParameter();
                pIdError.ParameterName = "Id";
                pIdError.Value = id;
                pIdError.SqlDbType = SqlDbType.NVarChar;

                //cria uma lista de parametros
                List<SqlCeParameter> list = new List<SqlCeParameter>();
                list.Add(pIdError);


                //cria o DataReader que receberá o resultado da  consulta
                SqlCeDataReader reader = con.Select(sql, list);

                while (reader.Read())
                {
                    ErrorType error = new ErrorType(reader.GetString(0), reader.GetString(1));
                    return error;
                }

                return null;
            }
            finally
            {
                con.Close();
            }
        }

        #endregion
    }
}