﻿#region

using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlServerCe;
using LoadReview.Persistencia;
using LoadReviewLibrary.Persistencia.Dao.Generics;
using LoadReviewLibrary.Persistencia.Pojo;

#endregion

namespace LoadReviewLibrary.Persistencia.Dao.Implementation
{
    internal class LocationDao : ILocationDao
    {
        private const String SQL_SELECT_LOCATION =
            "SELECT * FROM T_EMPLOYEE_MASTER func, T_LOCATION_MASTER loca WHERE func.EMPLOYEE_ID = @employeeId AND func.LOCATION_ID = loca.LOCATION_ID";

        #region ILocationDao Members

        public Location Select(string locationId)
        {
            ConnectionPDA con = new ConnectionPDA();
            try
            {
                SqlCeParameter parameter = new SqlCeParameter();
                List<SqlCeParameter> list = new List<SqlCeParameter>();

                parameter.ParameterName = "Id";
                parameter.SqlDbType = SqlDbType.NVarChar;
                parameter.Value = locationId;

                SqlCeDataReader reader = con.Select(SQL_SELECT_LOCATION, list);

                while (reader.Read())
                {
                    Location location = new Location(reader.GetString(0), reader.GetString(1));
                    return location;
                }

                return null;
            }
            finally
            {
                con.Close();
            }
        }

        public Location Select(Employee emp)
        {
            //cria a conexão
            ConnectionPDA con = new ConnectionPDA();

            try
            {
                //cria o parametro
                SqlCeParameter employeeId = new SqlCeParameter();
                //cria lista para armazernar o parametro 
                List<SqlCeParameter> list = new List<SqlCeParameter>();

                //define as propriedes do parametro @employeeId
                employeeId.ParameterName = "employeeId";
                employeeId.Value = emp.User;
                employeeId.SqlDbType = SqlDbType.NVarChar;

                //adiciona o parametro à lista
                list.Add(employeeId);

                //obtem o resultado da consulta SQL
                SqlCeDataReader reader = con.Select(SQL_SELECT_LOCATION, list);

                while (reader.Read())
                {
                    Location location = new Location(reader.GetString(5), reader.GetString(6));
                    return location;
                }
            }
            finally
            {
                con.Close();
            }

            return null;
        }

        #endregion
    }
}