﻿#region

using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlServerCe;
using LoadReview.Persistencia;
using LoadReviewLibrary.Persistencia.Dao.Generics;
using LoadReviewLibrary.Persistencia.Pojo;

#endregion

namespace LoadReviewLibrary.Persistencia.Dao.Implementation
{
    internal class TypeConferenceDao : ITypeConferenceDao
    {
        private const String SQL_SELECT =
            "SELECT T.TYPE_CONFERENCE_ID, TYPE_CONFERENCE_DESCRIPTION FROM T_TYPE_CONFERENCE T, T_COMPANY_LOCATION C WHERE T.TYPE_CONFERENCE_ID = C.TYPE_CONFERENCE_ID AND C.COMPANY_ID = @Company AND C.LOCATION_ID = @locationId";

        #region ITypeConferenceDao Members

        public TypeConference Select(String compId, String locationId)
        {
            //cria Conexão
            ConnectionPDA con = new ConnectionPDA();

            try
            {
                //cria os parametros
                SqlCeParameter companyId = new SqlCeParameter();
                SqlCeParameter locaId = new SqlCeParameter();

                //cria lista para guardar os parametros
                List<SqlCeParameter> list = new List<SqlCeParameter>();

                //define propriedades do parametro @Company
                companyId.ParameterName = "Company";
                companyId.Value = compId;
                companyId.SqlDbType = SqlDbType.NVarChar;

                //define propriedades do parametro @locationId
                locaId.ParameterName = "locationId";
                locaId.Value = locationId;
                locaId.SqlDbType = SqlDbType.NVarChar;

                //adiciona os parametros à lista
                list.Add(companyId);
                list.Add(locaId);


                //Obtem o resultado da consulta 
                SqlCeDataReader reader = con.Select(SQL_SELECT, list);

                while (reader.Read())
                {
                    TypeConference typeConference =
                        new TypeConference(reader.GetInt32(reader.GetOrdinal("TYPE_CONFERENCE_ID")),
                                           reader.GetString(reader.GetOrdinal("TYPE_CONFERENCE_DESCRIPTION")));
                    return typeConference;
                }

                return null;
            }
            finally
            {
                con.Close();
            }
        }

        #endregion
    }
}