﻿#region

using System;
using System.Collections.Generic;
using System.Data.SqlServerCe;
using LoadReview.Persistencia;
using LoadReviewLibrary.Persistencia.Dao.Generics;
using LoadReviewLibrary.Persistencia.Pojo;

#endregion

namespace LoadReviewLibrary.Persistencia.Dao.Implementation
{
    internal class VehicleDao : IVehicleDao
    {
        private const String SQL_SELECT_VEHICLE =
            "SELECT * FROM T_LOAD_MASTER WHERE COMPANY_ID = @Company AND LOCATION_ID = @Location AND TRIP_NUMBER = @trip";

        #region IVehicleDao Members

        public Vehicle Select(string cp, string locationId, int tripn)
        {
            ConnectionPDA con = new ConnectionPDA();

            try
            {
                SqlCeParameter company = new SqlCeParameter();
                SqlCeParameter location = new SqlCeParameter();
                SqlCeParameter trip = new SqlCeParameter();

                List<SqlCeParameter> parameters = new List<SqlCeParameter>();

                company.ParameterName = "Company";
                company.Value = cp;

                location.ParameterName = "Location";
                location.Value = locationId;

                trip.ParameterName = "trip";
                trip.Value = tripn;

                parameters.Add(company);
                parameters.Add(location);
                parameters.Add(trip);

                SqlCeDataReader reader = con.Select(SQL_SELECT_VEHICLE, parameters);

                while (reader.Read())
                {
                    Vehicle vehicle = new Vehicle(reader.GetString(reader.GetOrdinal("VEHICLE_ID")),
                                                  reader.GetString(reader.GetOrdinal("VEHICLE_DESCRIPTION")));
                    ;
                    return vehicle;
                }

                return null;
            }
            finally
            {
                con.Close();
            }
        }

        #endregion
    }
}