﻿#region

using System;
using System.Windows.Forms;
using LoadReviewLibrary.Persistencia.Pojo;

#endregion

namespace LoadReview
{
    public partial class SelecaoConferencia : Form
    {
        private CompanyLocation companyLocation;

        /// <summary>
        /// Construtor.
        /// Inicializa componentes e configura a data exibida no rodapé.
        /// </summary>
        private SelecaoConferencia()
        {
            InitializeComponent();
        }

        public SelecaoConferencia(CompanyLocation cp) : this()
        {
            companyLocation = cp;
        }


        /// <summary>
        /// Evento gerado pelo botão de  conferência de Pallet.
        /// chama a tela de identificação do Pallet.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnPalletClick(object sender, EventArgs e)
        {
            ReadPallet form = new ReadPallet(companyLocation);
            form.Show();
        }


        /// <summary>
        /// Evento gerado pelo botão de  conferência de Carga.
        /// Chama a tela para conferência de carga.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnCargaClick(object sender, EventArgs e)
        {
            ConferenciaCarga form = new ConferenciaCarga();
            form.Show();
        }

        /// <summary>
        /// Evento gerado pelo botão de Exit.
        /// Obtem uma instancia da classe saida e mostra 
        /// mensagem de confirmação para o usuário.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnSaidaClick(object sender, EventArgs e)
        {
            Exit saida = Exit.getInstance();
            saida.ShowMessageSaida();
        }

        private void SelecaoConferencia_Load(object sender, EventArgs e)
        {
        }
    }
}