﻿#region

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.IO;
using System.Web.Services;

using LoadReviewLibrary.Persistencia.Pojo;
using LoadReviewSync.persistencia;
using LoadReviewSync.persistencia.dao;
using LoadReviewSync.util;

#endregion

namespace LoadReviewSync
{
    /// <summary>
    /// Summary description for RDtoPDA
    /// </summary>
    [WebService(Namespace = "http://www.rd-help.com/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [ToolboxItem(false)]
    // To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
        // [System.Web.Script.Services.ScriptService]
    public class RDtoPDA : WebService
    {
        [WebMethod]
        public String sendPallet(String companyLocation)
        {
            CompanyLocation cpl = new CompanyLocation();
            XmlFormater xmlF = new XmlFormater(cpl.GetType());
            cpl = (CompanyLocation)xmlF.DesSerializar(companyLocation);
            
            PalletDaoSync palletDao = (PalletDaoSync) DaoFactory.CreatePalletDao();

            List<Pallet> pallets = palletDao.PalletList(cpl, false);
            
            XmlFormater xmlFormater = new XmlFormater(pallets.GetType());
            
            String xml = xmlFormater.Serializar(pallets);

            
            
            
            DateTime now = DateTime.Now;
            String data = now.Hour.ToString() + now.Minute.ToString() + now.Second.ToString() +
                          now.Millisecond.ToString();
            String filename = "C:\\LoadReview\\LoadReviewSync\\zip\\" + data + ".nx" ;
            
           
            
            SerializationWriter writer = new SerializationWriter();
            writer.WriteObject(pallets);
            writer.AppendTokenTables();

            MemoryStream memoryStream = (MemoryStream) writer.BaseStream;

            FileStream fileStream = File.Create(filename);

            fileStream.Write(memoryStream.GetBuffer(), 0, (int)memoryStream.Length);
            fileStream.Close();


            SharpZip zip = new SharpZip();
            zip.CreateZipFile(filename + ".zip", new FileInfo(filename));
            return data + ".nx" + ".zip";

            
            /*
            byte[] serializedData = MiniLZO.Compress(stream.GetBuffer(), (int) stream.Length);
            
            
            fileStream.Write(serializedData, 0, serializedData.Length - 1);
            fileStream.Close();


           
             */
            
            
            //return CreateFile.CreateZipFile(xml);


        }

        [WebMethod] 
        public String sendTripNumbers(String companyLocation)
        {
        CompanyLocation cpl = new CompanyLocation();
        XmlFormater xmlF = new XmlFormater(cpl.GetType());

        cpl = (CompanyLocation)xmlF.DesSerializar(companyLocation);

        SyncDao syncDao = (SyncDao)DaoFactory.CreateSyncDao();

        List<int> trips = syncDao.TripNumberList(cpl, false);

        XmlFormater xmlFormater = new XmlFormater(trips.GetType());

        String retorno = xmlFormater.Serializar(trips);

        return retorno;
            
        }
        
        [WebMethod]
        public String sendBay(String companyLocation)
        {
            ConnectionSync connectionSync = new ConnectionSync();
            connectionSync.Open();
            try
            {
                CompanyLocation cpl = new CompanyLocation();
                XmlFormater xmlF = new XmlFormater(cpl.GetType());
                cpl = (CompanyLocation)xmlF.DesSerializar(companyLocation);

                BayDaoSync bayDaoSync = (BayDaoSync) DaoFactory.CreateBayDao(connectionSync);
                List<Bay> bays = bayDaoSync.ListBay(cpl);

                XmlFormater xmlFormater = new XmlFormater(bays.GetType());
                String retorno = xmlFormater.Serializar(bays);

                return retorno;
            }
            finally
            {
                connectionSync.Close();
            }
        }

        [WebMethod]
        public void Teste()
        {
            CompanyLocation cp = new CompanyLocation();
            cp.Company = new Company("1", null, null);
            cp.Location = new Location("7", null);
            int trip = 1;
            
            XmlFormater xmlFormater = new XmlFormater(cp.GetType());
            String listBayXml = sendPallet(xmlFormater.Serializar(cp));
            
            List<Pallet> listPallet = new List<Pallet>();

            XmlFormater xmlF = new XmlFormater(listPallet.GetType());
            listPallet = (List<Pallet>)xmlF.DesSerializar(listBayXml);
        }



    }
}