﻿#region

using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using LoadReviewLibrary.Persistencia.Dao.Generics;
using LoadReviewLibrary.Persistencia.Pojo;

#endregion

namespace LoadReviewSync.persistencia.dao
{
    public class ErrorTypeDao : IErrorTypeDao
    {
        private const String SQL_SELECT_ERROR = "SELECT * FROM T_REVIEW_ERROR_TYPE WHERE ERROR_ID = @id";

        private SqlCommand cmdSelect;

        private List<SqlParameter> parameters;


        public ErrorTypeDao(ConnectionSync connectionSync)
        {
            this.connectionSync = connectionSync;

            cmdSelect = new SqlCommand(SQL_SELECT_ERROR, connectionSync.connection);

            parameters = new List<SqlParameter>();
        }

        private ConnectionSync connectionSync { get; set; }

        #region IErrorTypeDao Members

        public ErrorType Select(string id)
        {
            try
            {
                SqlParameter erroid = new SqlParameter();
                erroid.ParameterName = "id";
                erroid.Value = id;

                List<SqlParameter> list = new List<SqlParameter>();

                list.Add(erroid);

                SqlDataReader reader = connectionSync.Select(cmdSelect, list);

                while (reader.Read())
                {
                    ErrorType error = new ErrorType(reader.GetString(reader.GetOrdinal("ERROR_ID")),
                                                    reader.GetString(reader.GetOrdinal("ERROR_DESCRIPTION")));

                    reader.Close();
                    return error;
                }
            }
            catch (SqlException e)
            {
                throw new Exception(e.Message);
            }

            return null;
        }

        #endregion
    }
}