﻿#region

using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using LoadReviewLibrary.Persistencia.Dao.Generics;
using LoadReviewLibrary.Persistencia.Pojo;

#endregion

namespace LoadReviewSync.persistencia.dao
{
    public class VehicleDaoSync : IVehicleDao
    {
        private const String SQL_SELECT_VEHICLE =
            "SELECT VEHICLE_ID, VEHICLE_DESCRIPTION FROM T_VEHICLE_MASTER WHERE COMPANY_ID = @Company AND LOCATION_ID = @Location";


        private SqlCommand cmdSelect;
        private ConnectionSync connectionSync;
        private List<SqlParameter> parameters;


        public VehicleDaoSync(ConnectionSync connectionSync)
        {
            this.connectionSync = connectionSync;
            cmdSelect = new SqlCommand(SQL_SELECT_VEHICLE, connectionSync.connection);
            parameters = new List<SqlParameter>();
        }

        #region IVehicleDao Members

        public Vehicle Select(string cp, string locationId, int tripn)
        {
            parameters.Clear();

            try
            {
                SqlParameter company = new SqlParameter();
                SqlParameter location = new SqlParameter();
                SqlParameter trip = new SqlParameter();


                company.ParameterName = "Company";
                company.Value = cp;

                location.ParameterName = "Location";
                location.Value = locationId;


                parameters.Add(company);
                parameters.Add(location);


                SqlDataReader reader = connectionSync.Select(cmdSelect, parameters);

                while (reader.Read())
                {
                    Vehicle vehicle = new Vehicle(reader.GetString(reader.GetOrdinal("VEHICLE_ID")),
                                                  reader.GetString(reader.GetOrdinal("VEHICLE_DESCRIPTION")));

                    reader.Close();
                    return vehicle;
                }

                return null;
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
        }

        #endregion
    }
}